Package ru.bitel.bgbilling.modules.npay.server.task

# Class Calculator

java.lang.Object
ru.bitel.bgbilling.kernel.task.server.TaskBase
ru.bitel.bgbilling.modules.npay.server.task.Calculator

All Implemented Interfaces:
  `java.lang.Runnable`

    public class Calculator
    extends ru.bitel.bgbilling.kernel.task.server.TaskBase

- ## Field Summary

  ### Fields inherited from class ru.bitel.bgbilling.kernel.task.server.TaskBase

  `defaultDescription, log, moduleId, setup, STATUS_FINISHED, STATUS_FINISHED_INTERRUPTED, STATUS_NOTSTARTED, STATUS_WORKING, taskId, taskSetup`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `Calculator()` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `protected void` | `executeTask()` |
  `ru.bitel.bgbilling.modules.npay.server.calculate.ServiceConfigCache` | `getConfigCache()` |
  `ServiceCostCache` | `getCostCache()` |
  `java.lang.String` | `getDescription()` |
  `protected boolean` | `initTask()` |
  `boolean` | `isCalcErrors()` |
  `void` | `setActiveFromDate​(java.util.Calendar value)` | Устанавливает дату, с которой статус считать активным для режима предтарификации.
  `void` | `setCids​(java.lang.String codes)` | Устанавливает коды договоров, для которых производится калькуляция.
  `void` | `setContractLabelIds​(java.util.List<java.lang.Integer> contractLabelIds)` |
  `void` | `setModuleAccountMap​(java.util.Map<java.lang.Integer,​ModuleAccount> moduleAccountMap)` |
  `void` | `setModuleAmountMap​(java.util.Map<java.lang.Integer,​ModuleAmount> moduleAmountMap)` |
  `void` | `setModuleQuantityMap​(java.util.Map<java.lang.Integer,​ModuleQuantity> moduleQкuantityMap)` |
  `void` | `setPreCalc()` | Устанавливает режим предкалькуляции, при котором результаты в базу не заносится.
  `void` | `setServiceObjectList​(java.util.List<ServiceObject> serviceObjectList)` | Устанавливает набор услуг с периодами.
  `void` | `setTariffList​(java.util.List<ContractTariff> tariffList)` | Устанавливает тарифы с периодами.
  `void` | `setTariffOptionEnable​(boolean tariffOptionEnable)` | Устанавливает флаг учёта тарифных опции при тарификации.

  ### Methods inherited from class ru.bitel.bgbilling.kernel.task.server.TaskBase

  `getFinishTime, getModuleId, getOperatingTime, getStartTime, getTaskSetup, getTaskStatus, getWorkingTime, initModuleId, initTask, putMyselfIntoTable, removeMyselfFromTable, run, runLocal, setExecutingTime, setModuleId, startTask`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Calculator

    public Calculator()

- ## Method Details

  - ### setCids

    public void setCids​(java.lang.String codes)
    Устанавливает коды договоров, для которых производится калькуляция.
    Parameters:
      `codes` - коды договоров через запятую.

  - ### setContractLabelIds

    public void setContractLabelIds​(java.util.List<java.lang.Integer> contractLabelIds)

  - ### setPreCalc

    public void setPreCalc()
    Устанавливает режим предкалькуляции, при котором результаты в базу не заносится. Если не установлена дата, с которой статус активен, то он устанавливается равным `TaskBase.getOperatingTime()`. Это нужно для выполнения предкалькуляции в закрытом статусе, чтобы оценить сумму абонплаты после его открытия.

  - ### setActiveFromDate

    public void setActiveFromDate​(java.util.Calendar value)
    Устанавливает дату, с которой статус считать активным для режима предтарификации.
    Parameters:
      `value` - если null, то будет выполнена калькуляция с текущими статусами, как есть.

  - ### setServiceObjectList

    public void setServiceObjectList​(java.util.List<ServiceObject> serviceObjectList)
    Устанавливает набор услуг с периодами.
    Parameters:
      `serviceObjectList` - если null, то будет выполнена калькуляция с услугами из БД.

  - ### setTariffList

    public void setTariffList​(java.util.List<ContractTariff> tariffList)
    Устанавливает тарифы с периодами.
    Parameters:
      `tariffList` - если null, то будет выполнена калькуляция с тарифами из БД.

  - ### setTariffOptionEnable

    public void setTariffOptionEnable​(boolean tariffOptionEnable)
    Устанавливает флаг учёта тарифных опции при тарификации.
    Parameters:
      `tariffOptionEnable` -

  - ### getCostCache

    public ServiceCostCache getCostCache()

  - ### getConfigCache

    public ru.bitel.bgbilling.modules.npay.server.calculate.ServiceConfigCache getConfigCache()

  - ### isCalcErrors

    public boolean isCalcErrors()

  - ### getDescription

    public java.lang.String getDescription()
    Specified by:
      `getDescription` in class `ru.bitel.bgbilling.kernel.task.server.TaskBase`

  - ### initTask

    protected boolean initTask()
    Specified by:
      `initTask` in class `ru.bitel.bgbilling.kernel.task.server.TaskBase`

  - ### executeTask

    protected void executeTask()
    Specified by:
      `executeTask` in class `ru.bitel.bgbilling.kernel.task.server.TaskBase`

  - ### setModuleAmountMap

    public void setModuleAmountMap​(java.util.Map<java.lang.Integer,​ModuleAmount> moduleAmountMap)

  - ### setModuleAccountMap

    public void setModuleAccountMap​(java.util.Map<java.lang.Integer,​ModuleAccount> moduleAccountMap)

  - ### setModuleQuantityMap

    public void setModuleQuantityMap​(java.util.Map<java.lang.Integer,​ModuleQuantity> moduleQкuantityMap)